<template>
  <v-group>
    <v-rect :config="node.config.container" />
    <v-group v-for="(note, i) in notes" :key="note.name">
      <v-rect
        :config="node.config.createWhiteKey(i, note.name)"
        @mousedown="playNote(note.name, $event)"
        @mouseup="releaseNote(note.name, $event)"
        @mouseout="releaseNote(note.name, $event)"
      />
      <v-text
        :config="node.config.createWhiteTooltip(i, note.key)"
        @mousedown="playNote(note.name, $event)"
        @mouseup="releaseNote(note.name, $event)"
      />
    </v-group>
    <v-group v-for="(note, i) in notes" :key="`${note.name}-black`">
      <v-rect
        :config="node.config.createBlackKey(i, `${note.name}.black`)"
        v-if="note.hasBlack"
        @mousedown="playNote(`${note.name}.black`, $event)"
        @mouseup="releaseNote(`${note.name}.black`, $event)"
        @mouseout="releaseNote(`${note.name}.black`, $event)"
      />
      <v-text
        :config="node.config.createBlackTooltip(i, note.blackKey)"
        @mousedown="playNote(`${note.name}.black`, $event)"
        @mouseup="releaseNote(`${note.name}.black`, $event)"
      />
    </v-group>
    <v-group :config="node.config.outputsOrigin()">
      <GraphicPort :port="port" v-for="(port, i) in node.outputs" :key="`out-${i}`" />
    </v-group>
  </v-group>
</template>

<script lang="ts">
import { notes } from '@/lib/audio/utils/keyboard'
import { KeyboardWrapper } from '@/lib/gui/wrappers/KeyboardWrapper'
import GraphicPort from '../elements/GraphicPort.vue'

export default {
  name: "KeyboardNode",
  props: {
    index: Number,
    node: KeyboardWrapper
  },
  components: {
    GraphicPort
  },
  data: () => ({
    notes
  }),
  methods: {
    playNote(name: string, $event: any) {
      (this as any).node.attackNote(name);
      $event.cancelBubble = true
    },
    releaseNote(name: string, $event: any) {
      (this as any).node.releaseNote(name);
      $event.cancelBubble = true
    }
  }
}
</script>